/*******************************************************************************
    Copyright (c) 2011 Yahoo! Inc. All rights reserved.

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License. See accompanying LICENSE file.

    The Initial Developer of the Original Code is Shravan Narayanamurthy.
******************************************************************************/
/*
 * MedLDA_Train_Data_Formatter.h
 *
 *  Created on: 11-Jan-2011
 *      
 */

#ifndef MEDLDA_TRAIN_DATA_FORMATTER_H_
#define MEDLDA_TRAIN_DATA_FORMATTER_H_

#include "commons/Formatter/Data_Formatter.h"
#include "commons/DocumentWriter.h"
#include <fstream>
#include "boost/unordered_set.hpp"

namespace medlda {

class MedLDA_Train_Data_Formatter: public Data_Formatter {
public:
    MedLDA_Train_Data_Formatter();
    virtual ~MedLDA_Train_Data_Formatter();

    virtual void format();

    WordIndexDictionary& get_dictionary();

    int get_num_docs();

    int get_total_num_words();

protected:
    WordIndexDictionary _dict;
    int _num_docs, _num_words_in_all_docs;
    //boost::unordered_set<string> _stopWords;
    //std::ifstream _in;
    DocumentWriter* _doc_writer;
};

}
#endif /* MEDLDA_TRAIN_DATA_FORMATTER_H_ */
