#pragma once

#include <boost/random/variate_generator.hpp>
#include <boost/random/uniform_real.hpp>
#include <types.h>

namespace medlda {

using namespace boost; 

class InverseGaussian
{
public:
	InverseGaussian(void);
	~InverseGaussian(void);
	InverseGaussian(double dMu, double dScale) {
		m_iSet = 0;
		m_dMu = dMu;
		m_dScale = dScale;
	}

	double sample();

	void reset(double dMu, double dScale) {
		m_iSet = 0;
		m_dMu = dMu;
		m_dScale = dScale;
	}

	double nextGaussian();

        void setRNG(variate_generator<base_generator_type&, boost::uniform_real<> >* unif01);

private:
        variate_generator<base_generator_type&, boost::uniform_real<> >* _unif01;

	double m_dMu;
	double m_dScale;

	// for Gaussian random variable
	double m_dGset;
	int m_iSet;
};

}
