#pragma once

#include <boost/random/variate_generator.hpp>
#include <boost/random/uniform_real.hpp>
#include <types.h>

namespace medlda {

using namespace boost; 

class MVGaussian
{
public:
	MVGaussian(void);
	~MVGaussian(void);

	void nextMVGaussian(double *mean, double **precision, double *res, const int &n);

	void nextMVGaussianWithCholesky(double *mean, double **precisionLowerTriangular, double *res, const int &n) ;
        void setRNG(variate_generator<base_generator_type&, boost::uniform_real<> >* unif01);

private:
	double nextGaussian();

private:
        variate_generator<base_generator_type&, boost::uniform_real<> >* _unif01;
	// for Gaussian random variable
	int m_iSet;
	double m_dGset;
};

}
