#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <map>
#include <set>
#include <fstream>
#include <vector>

using namespace std;
int main(int argc, char *argv[]) {
  if (argc != 3) {
    fprintf(stderr, "Usage: get_label input output\n");
    exit(1);
  }
  ifstream fin(argv[1]);
  if (!fin) {
    fprintf(stderr, "open %s failed\n", argv[1]);
    exit(1);
  }
  std::string buffer_line;
  vector<vector<int> > res;
  int test_id = 0;
  while(getline(fin, buffer_line)) {
    res.push_back(vector<int>());
    size_t start_pos = 0;
    int first_label = -1;
    bool first = true;
    while (1) {
      double score;
      int label;
      size_t blank_pos = buffer_line.find(" ", start_pos);
      size_t blank_pos2 = buffer_line.find(" ", blank_pos + 1);
      if (blank_pos2 == std::string::npos) {
        sscanf(&buffer_line[start_pos], "%d %lf", &label, &score);
        if (score > 0) {
          res[test_id].push_back(label);
        }
        if (first) {
          first_label = label;
          first = false;
        }
        break;
      }
      sscanf(&buffer_line[start_pos], "%d %lf", &label, &score);
      if (score > 0) {
        res[test_id].push_back(label);
      }
      if (first) {
        first_label = label;
        first = false;
      }
      start_pos = blank_pos2 + 1;
    }
    if (res[test_id].size() == 0UL) {
      res[test_id].push_back(first_label);
    }
    test_id++;
  }
  FILE *fp = fopen(argv[2], "w");
  for (size_t i = 0; i < res.size(); ++i) {
    fprintf(fp, "%d", res[i][0]);
    for (size_t j = 1; j < res[i].size(); ++j) {
      fprintf(fp, ",%d", res[i][j]);
    }
    fprintf(fp, "\n");
  }
  fclose(fp);
}


